## esys-particle 2.3.5+dfsg2

=== CMakeLists.txt ===
PROJECT(Esys C CXX)
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)


FIND_PACKAGE(Boost COMPONENTS system filesystem python thread REQUIRED)
INCLUDE(FindPythonLibs)

INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/Foundation)
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/Parallel)
INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_DIRS})
SET(CMAKE_C_COMPILER mpicc)
SET(CMAKE_CXX_COMPILER mpicxx)

ADD_DEFINITIONS(-DPACKAGE_NAME="esys")
ADD_DEFINITIONS(-DPACKAGE_VERSION="2.1")

#===========================================================
ADD_SUBDIRECTORY("${CMAKE_SOURCE_DIR}/Foundation")
ADD_SUBDIRECTORY("${CMAKE_SOURCE_DIR}/Fields")
ADD_SUBDIRECTORY("${CMAKE_SOURCE_DIR}/Geometry")
ADD_SUBDIRECTORY("${CMAKE_SOURCE_DIR}/Model")
ADD_SUBDIRECTORY("${CMAKE_SOURCE_DIR}/pis")
ADD_SUBDIRECTORY("${CMAKE_SOURCE_DIR}/Tools")
ADD_SUBDIRECTORY("${CMAKE_SOURCE_DIR}/ntable")
ADD_SUBDIRECTORY("${CMAKE_SOURCE_DIR}/tml")
ADD_SUBDIRECTORY("${CMAKE_SOURCE_DIR}/ppa/src")
ADD_SUBDIRECTORY("${CMAKE_SOURCE_DIR}/Python")


ADD_SUBDIRECTORY("${CMAKE_SOURCE_DIR}/Parallel")
#===========================================================

=== Foundation/CMakeLists.txt ===
FILE(GLOB FOUNDATION_SRC_LIB "*.cpp")
#===========================================================
ADD_LIBRARY(Foundation SHARED ${FOUNDATION_SRC_LIB})
TARGET_LINK_LIBRARIES(Foundation ${Boost_LIBRARIES} ${PYTHON_LIBRARIES})
INSTALL(TARGETS Foundation DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)

=== Parallel/CMakeLists.txt ===
#===========================================================
ADD_LIBRARY(Parallel SHARED ASubLattice.cpp LatticeMaster.cpp mpia2abuf.cpp mpibarrier.cpp mpibuf.cpp mpicmdbuf.cpp mpisgbuf.cpp mpisgvbuf.cpp mpivbuf.cpp SubLatticeControler.cpp SubLattice.cpp CheckPointer.cpp CheckPointController.cpp CheckPointParams.cpp MpiInfo.cpp GeometryReader.cpp CheckPointInfo.cpp CheckPointLoader.cpp LatticeParam.cpp BroadCast_cmd.cpp BMesh2D_cmd.cpp GetRef_cmd.cpp Mesh2DReader.cpp)
TARGET_LINK_LIBRARIES(Parallel Foundation Geometry TmlMessage TmlType TmlComm Fields ${Boost_LIBRARIES} ${PYTHON_LIBRARIES})
INSTALL(TARGETS Parallel DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)

=== tml/CMakeLists.txt ===
ADD_SUBDIRECTORY("${CMAKE_SOURCE_DIR}/tml/comm")
ADD_SUBDIRECTORY("${CMAKE_SOURCE_DIR}/tml/message")
ADD_SUBDIRECTORY("${CMAKE_SOURCE_DIR}/tml/type")

=== Python/MpiPython/CMakeLists.txt ===
FILE(GLOB MODEL_SRC_LIB "*.cpp")
#===========================================================

#ADD_EXECUTABLE(esysparticle ${MODEL_SRC_LIB})
#TARGET_LINK_LIBRARIES(esysparticle Parallel libLsmPy ${Boost_LIBRARIES} ${PYTHON_LIBRARIES})
#INSTALL(TARGETS esysparticle DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)

=== Tools/ExtractFractures/CMakeLists.txt ===
FILE(GLOB SRC "*.cpp")
#===========================================================
ADD_EXECUTABLE(fracextract ${SRC})
TARGET_LINK_LIBRARIES(fracextract Geometry)
INSTALL(TARGETS fracextract DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)

=== Tools/ExtractStrain/CMakeLists.txt ===
FILE(GLOB SRC "*.cpp")
#===========================================================
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/ntable/src)
ADD_EXECUTABLE(strainextract ${SRC})
TARGET_LINK_LIBRARIES(strainextract Foundation)
INSTALL(TARGETS strainextract DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)

=== Tools/StressCalculator/CMakeLists.txt ===
FILE(GLOB SRC "*.cpp")
#===========================================================
ADD_EXECUTABLE(raw2tostress ${SRC})
TARGET_LINK_LIBRARIES(raw2tostress Foundation)
INSTALL(TARGETS raw2tostress DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)

=== Python/esys/lsm/geometry/CMakeLists.txt ===
#===========================================================

ADD_LIBRARY(lsmgeometry SHARED SimpleBlockPy.cpp MiscPy.cpp DistConnectionsPy.cpp TaggedIdConnectionPy.cpp IteratorPy.cpp ParticleCollectionPy.cpp CubicBlockPy.cpp GrainCollectionPy.cpp GrainPy.cpp PackerPy.cpp GougeConfigPrmsPy.cpp GougeConfigPy.cpp HexagBlockPy.cpp SimpleSpherePy.cpp SimpleSphereNeighboursPy.cpp SimpleSphereCollectionPy.cpp)
ADD_LIBRARY(GeometryPy SHARED ExportModuleGeometry.cpp)

TARGET_LINK_LIBRARIES(lsmgeometry ${Boost_LIBRARIES} ${PYTHON_LIBRARIES})
TARGET_LINK_LIBRARIES(GeometryPy ${Boost_LIBRARIES} ${PYTHON_LIBRARIES})
INSTALL(TARGETS lsmgeometry DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)
INSTALL(TARGETS GeometryPy DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)

=== debian/changelog ===
esys-particle (2.3.5+dfsg2-7) unstable; urgency=medium

  * [3302028] Disable autopkgtests on 32 bit archs. (Closes: #1080196, #901849)
  * [f51a362] d/control: set Standards-Version to 4.7.0

 -- Anton Gladky <gladk@debian.org>  Sat, 26 Oct 2024 20:08:29 +0200

esys-particle (2.3.5+dfsg2-6) unstable; urgency=medium

  [ Jonathan Bergh ]
  * [72b9494] Replace htmladdnormallink with href. (Closes: #1013616)

  [ Anton Gladky ]
  * [7886d42] Set Standards-Version to 4.6.1

 -- Anton Gladky <gladk@debian.org>  Fri, 23 Sep 2022 15:12:16 +0200

esys-particle (2.3.5+dfsg2-5) unstable; urgency=medium

  * [24c7cfe] Switch to libltdl-dev. (Closes: #1009040)
  * [a4fb4a7] Remove _form0.ps. (Closes: #856677)
  * [d487a3d] Minor updates in d/rules
  * [355dd7e] Update watch file format version to 4.

 -- Anton Gladky <gladk@debian.org>  Tue, 26 Apr 2022 06:06:40 +0200

esys-particle (2.3.5+dfsg2-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Patch: Don't call Py_Initialize() before Py_Main(), fixing sys.path on
    Python 3.10. (Closes: #1009240)

 -- Stefano Rivera <stefanor@debian.org>  Wed, 13 Apr 2022 21:24:02 -0400

esys-particle (2.3.5+dfsg2-4) unstable; urgency=medium

  * Team upload
  * [524cf83] Add patch to correctly detect Python3.10 and 3.11

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 17 Jan 2022 16:16:32 +0100

esys-particle (2.3.5+dfsg2-3) unstable; urgency=medium

  * [2db959e] Force using C++14. (Closes: #984051)

 -- Anton Gladky <gladk@debian.org>  Thu, 21 Oct 2021 22:06:21 +0200

esys-particle (2.3.5+dfsg2-2) unstable; urgency=medium

  * [8a49eb9] Add noddebs env variable
  * [ba21f6a] Build against vtk9
  * [ed64d4e] Bump debhelper from old 12 to 13.
  * [5373e43] Update renamed lintian tag names in lintian overrides.
  * [7003b18] Update standards version to 4.5.1, no changes needed.
  * [d782187] Set Standards-Version 4.6.0
  * [e10828c] Drop Multi-Arch: foreig
  * [444493c] Remove unused doc-base file

 -- Anton Gladky <gladk@debian.org>  Thu, 30 Sep 2021 22:43:35 +0200

esys-particle (2.3.5+dfsg2-1) unstable; urgency=medium

  [ Adrian Bunk ]
  * [a2a3461] Fix the manpage section number. (Closes: #962253)

  [ Anton Gladky ]
  * [79195f3] Set upstream metadata fields: Repository, Repository-Browse.
  * [bd11b4b] Drop unnecessary dependency on dh-autoreconf.
  * [9be1eac] Drop unnecessary dh arguments: --parallel
  * [994720f] Update standards version to 4.5.0, no changes needed.
  * [758e80e] Minor patch update
  * [2bf0c70] Add .gitlab-ci.yml
  * [08bdd6a] New upstream version 2.3.5+dfsg2

 -- Anton Gladky <gladk@debian.org>  Wed, 10 Jun 2020 22:57:41 +0200

=== debian/control ===
Source: esys-particle
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: science
Priority: optional
Build-Depends: autoconf,
               autoconf-archive,
               automake,
               debhelper-compat (= 13),
               dh-python,
               doxygen,
               graphviz,
               libboost-all-dev,
               libcppunit-dev,
               libltdl-dev,
               libtool,
               libvtk9-dev,
               mpi-default-bin,
               mpi-default-dev,
               python3-dev,
               python3-gengeo,
               texlive-latex-extra,
               texlive-fonts-recommended,
               texlive-latex-recommended
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/science-team/esys-particle/
Vcs-Git: https://salsa.debian.org/science-team/esys-particle.git
Homepage: https://launchpad.net/esys-particle
Rules-Requires-Root: no

Package: esys-particle
Architecture: any
Depends: libjs-jquery,
         mpi-default-bin,
         python3,
         python3-gengeo,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: paraview
Pre-Depends: ${misc:Pre-Depends}
Description: Software for particle-based numerical modelling (MPI version)
 ESyS-Particle is Open Source software for particle-based numerical modelling.
 The software implements the Discrete Element Method (DEM), a widely used
 technique for modelling processes involving large deformations, granular flow
 and/or fragmentation. ESyS-Particle is designed for execution on parallel
 supercomputers, clusters or multi-core PCs running a Linux-based operating
 system. The C++ simulation engine implements spatial domain decomposition via
 the Message Passing Interface (MPI). A Python wrapper API provides flexibility
 in the design of numerical models, specification of modelling parameters and
 contact logic, and analysis of simulation data. ESyS-Particle has been
 utilised to simulate earthquake nucleation, comminution in shear cells, silo
 flow, rock fragmentation, and fault gouge evolution, to name but a few
 applications.

=== debian/rules ===
#!/usr/bin/make -f


PY3VER := $(shell py3versions -d -v | tr -d .)
export PYTHON = $(shell py3versions -d)

# less debug info to avoid running out of address space
ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel))
  export DEB_CXXFLAGS_MAINT_APPEND += -g1
endif

include /usr/share/dpkg/default.mk

%:
	dh $@ --with python3

export OMPI_MCA_plm_rsh_agent=/bin/false                #workaround to start MPI-applications in chroot
disable_auto_test_archs_mpi = hurd-i386 mips mipsel s390 s390x ia64 armhf i386

export LD_LIBRARY_PATH :=  $(CURDIR)/debian/esys-particle/usr/lib/${DEB_HOST_MULTIARCH}/:$(CURDIR)/debian/esys-particle/usr/lib/python3/dist-packages/esys/lsm/util/:$(CURDIR)/debian/esys-particle/usr/lib/python3/dist-packages/esys/lsm/:$(LD_LIBRARY_PATH);

export PYTHONPATH := $(CURDIR)/debian/esys-particle/usr/lib/python3/dist-packages/:$(PYTHONPATH);

export NO_PNG_PKG_MANGLE := 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CFLAGS := -Wall $(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS := -Wall $(shell dpkg-buildflags --get CXXFLAGS) -std=c++14
CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS := -lboost_system $(shell pkg-config --libs python3) $(shell dpkg-buildflags --get LDFLAGS)

extra_flags += CC=mpicc CXX=mpicxx CFLAGS='$(CFLAGS)' CXXFLAGS='$(CXXFLAGS)' CPPFLAGS='$(CPPFLAGS)'\
 LDFLAGS='$(LDFLAGS)' --with-vtk --with-latex --enable-vtk

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags) --with-boost-libdir=/usr/lib/$(DEB_HOST_MULTIARCH) --with-boost-python='boost_python$(PY3VER)'

execute_after_dh_auto_build:
	doxygen

execute_after_dh_auto_install:
ifeq (,$(filter $(DEB_HOST_ARCH),$(disable_auto_test_archs_mpi)))
	cd $(CURDIR)/debian/test; python3 box.py 15.0
endif
	find debian -name '*.pyc' -delete
	find debian -name '*.pyo' -delete
	find debian -name '*.la' -delete
	find debian -type d -name __pycache__ -exec rm -rf {} +

execute_after_dh_installdocs:
	find debian -name '*.md5' -delete
	find debian -name '_form0.ps' -delete

=== debian/tests/control ===
Tests: build1
Depends: esys-particle
Restrictions: allow-stderr
Architecture: !hurd-i386 !mips !mipsel !s390 !s390x !ia64 !armhf !i386
